=== src/lcl/icons/Makefile ===
.PHONY: all
all: *.png castleicons.lrs

castleicons.lrs: *.png
	lazres castleicons.lrs *.png

.PHONY: clean
clean:
	rm -f castleicons.lrs
