=== debian/changelog ===
castle-game-engine (7.0~alpha.2+dfsg1-5build3) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 16:38:37 +1100

castle-game-engine (7.0~alpha.2+dfsg1-5build2) noble; urgency=medium

  * No-change rebuild against libglib2.0-0t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 11 Mar 2024 22:08:09 +0000

castle-game-engine (7.0~alpha.2+dfsg1-5build1) noble; urgency=medium

  * No-change rebuild against libglib2.0-0t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 08 Mar 2024 04:02:58 +0000

castle-game-engine (7.0~alpha.2+dfsg1-5) unstable; urgency=medium

  * Applied patch to use local jquery version instead of web based one.
  * Remove statically linked libraries and object files from source package.

 -- Abou Al Montacir <abou.almontacir@sfr.fr>  Tue, 04 Apr 2023 11:08:10 +0200

castle-game-engine (7.0~alpha.2+dfsg1-4) unstable; urgency=medium

  * Fixed compilation on mipsel.
    On mipsel both CPUmips and CPUmipsel are defined by the compiler.
    (Closes: Bug#891683)

 -- Abou Al Montacir <abou.almontacir@sfr.fr>  Mon, 03 Apr 2023 15:07:29 +0200

castle-game-engine (7.0~alpha.2+dfsg1-3) unstable; urgency=medium

  * Removed unused binary files to fix lintian reported errors.
    Removed files are either unused statically liked libraries or some
    supplied windows programs or npm ignore file.
    These files were included in the source packages, but are not useful for
    Debian users.
  * Replaced use of web based jquery.js with debian packaged version.
    Added dependency on libjs-jquery dor documentation package.

 -- Abou Al Montacir <abou.almontacir@sfr.fr>  Sun, 02 Apr 2023 16:44:18 +0200

castle-game-engine (7.0~alpha.2+dfsg1-2) unstable; urgency=medium

  * Fixed build issue on arm64 and ppc64el.

 -- Abou Al Montacir <abou.almontacir@sfr.fr>  Mon, 24 Oct 2022 20:19:14 +0200

castle-game-engine (7.0~alpha.2+dfsg1-1) unstable; urgency=medium

  * Updated watch file and copyright file for importing new release.
  * New upstream version 7.0~alpha.2+dfsg1
  * Updated patches to new upstream release and removed legacy ones.
  * Updated compilation rules to take into account directory renaming.
  * Added a new patch from upstream to fix building documentation.
  * Fix UTF-8 BOM on some source files.

 -- Abou Al Montacir <abou.almontacir@sfr.fr>  Fri, 07 Oct 2022 08:34:14 +0200
