=== debian/watch ===
version=4
opts=\
compression=xz,\
repack,\
repacksuffix=+dfsg1,\
uversionmangle=s/-/~/,\
dversionmangle=s/\+dfsg(\d*)//,\
filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%castle-game-$1.tar.xz% \
    https://github.com/castle-engine/castle-engine/tags \
    (?:.*?/)?v?@ANY_VERSION@\.tar\.gz debian
